var express = require('express');
var app = express();
var bodyParser = require('body-parser');

var todos = [
  {
    id : 1,
    title : 'Learn redux',
    isComplete : false
  }
];

var nextId = 2;

app.use(bodyParser.json());

app.use(function(req, res, next) {
  res.setHeader('Access-Control-Allow-Origin', '*');
  res.setHeader("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
  res.setHeader('Access-Control-Allow-Methods', 'GET, POST, PUT, DELETE');
  next();
});

app.get('/api/todos', function(req, res) {
  res.send(todos);
});

app.post('/api/todos', function(req, res) {
  todos.push({
    id : nextId++,
    title : req.body.todo.title,
    isComplete : false
  });
  res.json(todos);
});

app.param('id', function(req, res, next, id) {
  var filteredArray = todos.filter(function(todo) {
    return todo.id === parseInt(id);
  });
  if (filteredArray.length > 0) {
    req.todo = filteredArray[0];
    next();
  } else {
    res.json({err:'todo id not found.'});
  }
});

app.get('/api/todos/:id', function(req, res) {
  res.json(req.todo);
});

app.post('/api/todos/:id', function(req, res) {
  var todo = todos[todos.indexOf(req.todo)];
  todo.title = req.body.todo.title;
  todo.isComplete = req.body.todo.isComplete;
  res.json(todo);
});

app.delete('/api/todos/:id', function(req, res) {
  todos.splice(todos.indexOf(req.todo), 1);
  res.json(todos);
});

console.log('Server listening on http://0.0.0.0:3001');
app.listen(3001, '0.0.0.0');
